/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "dlist.h"
#include "ftpd.h"
#include "locstr.h"
#include "string.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "face/edit.h"
#include "var.h"

tAddr::tAddr() {
    protocol=host=username=pass=path=file=NULL;
    port=0;
    mask=0;
};

void tAddr::print() {
    if (protocol) printf("protocol: %s\n",protocol);
    if (host) printf("host: %s\n",host);
    if (path) printf("path: %s\n",path);
    if (file) printf("file: %s\n",file);
    if (username) printf("username: %s\n",username);
    if (pass) printf("pass: %s\n",pass);
    printf("port: %i\n",port);
};

tAddr::~tAddr() {
    if (protocol) delete(protocol);
    if (path) delete(path);
    if (pass) delete(pass);
    if (username) delete(username);
    if (host) delete(host);
};

/**********************************************/
void make_url_from_download(tDownload *what,char *where) {
    *where=0;
    strcat(where,what->info->protocol);
    strcat(where,"://");
    if (what->info->username && !equal(what->info->username,"anonymous")) {
        strcat(where,what->info->username);
        strcat(where,":");
        if (what->info->pass) strcat(where,what->info->pass);
        strcat(where,"@");
    };
    strcat(where,what->info->host);
    if ((equal(what->info->protocol,"ftp")  && what->info->port!=21) ||
    	(equal(what->info->protocol,"http") && what->info->port!=80)){
    	char data[MAX_LEN];
    	sprintf(data,":%i",what->info->port);
    	strcat(where,data);
    };
    strcat(where,what->info->path);
    if (what->info->path[strlen(what->info->path)-1]!='/')
        strcat(where,"/");
    strcat(where,what->info->file);
};

char *make_simply_url(tDownload *what) {
    char *URL=new char[strlen(what->info->protocol)+strlen(what->info->host)+
                       strlen(what->info->path)+strlen(what->info->file)+6];
    *URL=0;
    /* Easy way to make URL from info  field
     */
    strcat(URL,what->info->protocol);
    strcat(URL,"://");
    strcat(URL,what->info->host);
    strcat(URL,what->info->path);
    if (what->info->path[strlen(what->info->path)-1]!='/')
        strcat(URL,"/");
    strcat(URL,what->info->file);
    return URL;
};
/**********************************************/
void tTriger::reset(){
	old=curent;
};

void tTriger::clear(){
	old=-1;
	curent=0;
};

void tTriger::set(int a ){
	curent=a;
};

int tTriger::change(){
	return old==curent?0:1;
};
/**********************************************/
tDownload::tDownload() {
    next=prev=NULL;
    who=NULL;
    info=NULL;
    LOG=NULL;
    SavePath=NULL;
    finfo.size=-1;
    finfo.type=T_NONE;
    finfo.body=NULL;
    finfo.perm=S_IWUSR | S_IRUSR;
    Start=Pause=0;
    Percent.clear();
    Attempt.clear();
    Status.clear();
    Size.clear();
    Speed.clear();
    owner=DL_ALONE;
    thread_id=0;
    editor=NULL;
    GTKCListRow=-1;
    config.proxy_host=NULL;
    config.proxy_user=NULL;
    config.proxy_pass=NULL;
    NanoSpeed=0;
    DIR=NULL;
    action=ACTION_NONE;
    SpeedLimit=NULL;
    ScheduleTime=0;
};

void tDownload::clear() {
    if (who) {
        delete(who);
        who=NULL;
    };
};

void tDownload::delete_editor() {
    if (editor)
        delete editor;
};

void tDownload::print() {
    //do nothing
};

void tDownload::convert_list_to_dir() {
	if (!who){
		return;
	};
	tFtpDownload *tmp=(tFtpDownload *)(who);
	tStringList *dir=tmp->dir();
    if (!dir){
    	return;
    };
    tString *temp=dir->first();
    if (!temp){
    	return;
    };
    if (equal_first(temp->body,"total")) {
        dir->del(temp);
        delete temp;
    };
    if (DIR){
    	DIR->done();
    }else{
    	DIR=new tDList(10);
    	DIR->init(0);
    };
    char *path,*savepath;
    if (info->mask==0){
	    int len=strlen(info->path);
    /* There are we make new file's path
     */
	    if (len>1 && info->path[len-1]!='/' && info->file[0]!='/')
	        path=sum_strings(info->path,"/",info->file);
	    else
	        path=sum_strings(info->path,info->file);
    /* There are we make new path where files will be saved
     */
    	if (SavePath) {
	        len=strlen(SavePath);
    	    if (len>1 && SavePath[len-1]!='/' && info->file[0]!='/')
        	    savepath=sum_strings(SavePath,"/",info->file);
        	else
	            savepath=sum_strings(SavePath,info->file);
    	} else {
        	savepath=copy_string(info->file);
    	};
    }else{
       path=copy_string(info->path);
       savepath=copy_string(SavePath);
       normalize_path(savepath);
       normalize_path(path);
    };
    temp=dir->last();
    while (temp) {
        tFileInfo prom;
        prom.name=NULL;
        prom.body=NULL;
        cut_string_list(temp->body,&prom,1);
        if (!equal(prom.name,".") && !equal(prom.name,"..")
        	&& (prom.type==T_DIR || info->mask==0 || check_mask(prom.name,info->file))) {
            tAddr *addrnew=new tAddr;
            tDownload *onenew=new tDownload;
            if (prom.type==T_DIR && info->mask && prom.name){
		        addrnew->path=sum_strings(path,"/",prom.name);
		        addrnew->file=copy_string(info->file);
   	    	    onenew->SavePath=sum_strings(savepath,"/",prom.name);
   	    	    delete prom.name;
   	    	    prom.name=NULL;
				mkdir(onenew->SavePath,prom.perm);
            }else{
            	addrnew->path=copy_string(path);
	            addrnew->file=prom.name;
	            onenew->SavePath=copy_string(savepath);
	        };
            addrnew->protocol=copy_string(info->protocol);
            addrnew->host=copy_string(info->host);
            addrnew->pass=copy_string(info->pass);
            addrnew->username=copy_string(info->username);
            addrnew->port=info->port;
	        addrnew->mask=info->mask;

            onenew->info=addrnew;

            onenew->config.timeout=config.timeout;
            onenew->config.time_for_sleep=config.time_for_sleep;
            onenew->config.number_of_attempts=config.number_of_attempts;
            onenew->config.passive=config.passive;
            onenew->config.permisions=config.permisions;
            onenew->config.get_date=config.get_date;
            onenew->config.proxy_type=config.proxy_type;
			onenew->config.proxy_port=config.proxy_port;
	    	onenew->config.proxy_host=copy_string(config.proxy_host);
	   		onenew->config.proxy_user=copy_string(config.proxy_user);
	    	onenew->config.proxy_pass=copy_string(config.proxy_pass);

            if (CFG.RECURSIVE_OPTIMIZE) {
                onenew->finfo.type=prom.type;
                onenew->finfo.size=prom.size;
                onenew->finfo.date=prom.date;
                if (config.permisions) onenew->finfo.perm=prom.perm;
                if (onenew->finfo.type==T_LINK) {
                    onenew->finfo.body=prom.body;
                };
            } else {
                if (prom.body) delete prom.body;
            };
            DIR->insert(onenew);
        } else {
            if (prom.name) delete(prom.name);
            if (prom.body) delete(prom.body);
        };
        dir->del(temp);
        delete temp;
        temp=dir->last();
    };
    delete (path);
    delete (savepath);
};

tDownload::~tDownload() {
    if (who) delete who;
    if (info) delete info;
    if (LOG) delete LOG;
    if (SavePath) delete SavePath;
    if (finfo.body) delete finfo.body;
    if (editor) delete editor;
    if (config.proxy_host) delete config.proxy_host;
    if (config.proxy_user) delete config.proxy_user;
    if (config.proxy_pass) delete config.proxy_pass;
    if (DIR) delete DIR;
};


//**********************************************/

tDList::tDList() {
    First=Last=NULL;
};

tDList::tDList(int key) {
    First=Last=NULL;
    OwnerKey=key;
};

int tDList::owner(tDownload *which) {
    if (which && which->owner==OwnerKey) return 1;
    return 0;
};

void tDList::insert(tDownload *what) {
    what->owner=OwnerKey;
    tQueue::insert(what);
};

void tDList::insert_before(tDownload *what,tDownload *where) {
    what->owner=OwnerKey;
    tQueue::insert_before(what,where);
};

void tDList::del(tDownload *what) {
    if (owner(what)) tQueue::del(what);
    else puts("***WARN***!!!"
                  "Attempt to delete download from list which does'nt contain it!");
};

void tDList::forward(tDownload *what) {
    if (what->next) {
        tDownload *temp=(tDownload *)(what->next);
        if ((temp->prev=what->prev))
            what->prev->next=temp;
        else
            Last=what->next;
        what->prev=temp;
        if ((what->next=temp->next))
            temp->next->prev=what;
        else
            First=what;
        what->prev->next=what;
    };
};

void tDList::backward(tDownload *what) {
    if (what->prev) {
        tDownload *temp=(tDownload *)(what->prev);
        if ((temp->next=what->next))
            what->next->prev=temp;
        else
            First=what->prev;
        what->next=temp;
        if ((what->prev=temp->prev))
            temp->prev->next=what;
        else
            Last=what;
        what->next->prev=what;
    };
};

tDownload *tDList::last() {
    return (tDownload *)(Curent=Last);
};

tDownload *tDList::first() {
    return (tDownload *)(Curent=First);
};

tDownload *tDList::next() {
    Curent=Curent->next;
    return (tDownload *)Curent;
};

tDownload *tDList::prev() {
    Curent=Curent->prev;
    return (tDownload *)Curent;
};

tDList::~tDList() {
    done();
};
