/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#ifndef T_DOWNLOADER
#define T_DOWNLOADER

#include "queue.h"
#include "liststr.h"
#include "log.h"

struct tFileInfo{
    char *name;
    char *body;
    int size;
    int type;
    int fdesc;
    int perm;
    int date;
};

struct tCfg{
	int timeout;
	int time_for_sleep;
	int number_of_attempts;
	int passive;
	int permisions;
	int get_date;
	char *proxy_host;
	int proxy_port;
	int proxy_type;
	char *proxy_user;
	char *proxy_pass;
};

struct tAddr;

class tDownloader{
    protected:
    tCfg config;
    tLog *LOG;
    int RetrNum;
    int Status;
    char *HOST,*USER,*PASS,*D_PATH;
    tFileInfo D_FILE;
	int D_PORT;
	int StartSize;
    int data;
    void make_full_pathes(const char *path,char *name,char *guess);
    public:
    	int treat();
     	int get_status();
     	virtual int get_start_size();
     	virtual void init_download(char *file,char *path);
     	void set_data(int a);
     	void short_init(tLog *log);
     	virtual int reconnect()=0;
    	virtual int init(tAddr *hostinfo,tLog *log,tCfg *cfg)=0;
    	virtual int create_file(char *where);
    	virtual int delete_file(char *where);
    	virtual void set_date_file(char *where);
    	virtual int get_readed()=0;
    	virtual int file_type();
    	virtual void set_file_info(tFileInfo *what);
    	virtual int get_child_status()=0;
    	virtual int get_size()=0;
     	virtual char *get_new_url();
     	virtual int reget()=0;
     	virtual int another_way_get_size();
     	virtual char *get_real_name();
    	virtual int download(unsigned int from,unsigned int len)=0;
    	virtual void done()=0;
    	virtual ~tDownloader();
};

enum{
	T_NONE,
	T_DIR,
	T_FILE,
	T_LINK,
	T_REDIRECT,
	T_DEVICE
};
/*
 * Statuses of tDownloader
 */

enum{
	D_NOTHING,
	D_QUERYING,
	D_DOWNLOAD,
	D_DOWNLOAD_BAD
};
#endif
