/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <gtk/gtk.h>
#include <stdio.h>
#include "../main.h"
#include "../var.h"
#include "../locstr.h"
#include "edit.h"
#include "list.h"

extern tMain aa;

tDownload *OneDownload=NULL;

void add_window_cancel() {
    delete OneDownload;
    OneDownload=NULL;
};

void add_window_ok() {
    if (OneDownload->editor->apply_changes()) return;
    delete OneDownload->editor;
    WaitList->insert(OneDownload);
    add_download_to_clist(OneDownload);
    aa.add_download_message(OneDownload);
    OneDownload=NULL;
};


void init_add_window(...) {
    if (OneDownload){
    	OneDownload->editor->popup();
    	return;
    };
    tDownload *what=OneDownload=new tDownload;
    char *temp=copy_string("ftp://somesite");
    tAddr *info=aa.analize(temp);
    what->info=info;
    what->SavePath=copy_string(CFG.GLOBAL_SAVE_PATH);
    what->config.timeout=CFG.TIME_OUT;
    what->config.time_for_sleep=CFG.RETRY_TIME_OUT;
    what->config.number_of_attempts=CFG.MAX_RETRIES;
    what->config.passive=CFG.FTP_PASSIVE_MODE;
    what->config.permisions=CFG.FTP_PERMISIONS;
    what->config.get_date=CFG.GET_DATE;

	if (CFG.USE_PROXY_FOR_FTP){
		    if (what->config.proxy_host) delete what->config.proxy_host;
		    what->config.proxy_host=copy_string(CFG.FTP_PROXY_HOST);
    		what->config.proxy_port=CFG.FTP_PROXY_PORT;
    		if (CFG.NEED_PASS_FTP_PROXY){
    			if (what->config.proxy_user) delete what->config.proxy_user;
    			what->config.proxy_user=copy_string(CFG.FTP_PROXY_USER);
    			if (what->config.proxy_pass) delete what->config.proxy_pass;
    			what->config.proxy_pass=copy_string(CFG.FTP_PROXY_PASS);
    		};
	};
	what->config.proxy_type=CFG.FTP_PROXY_TYPE;
    what->editor=new tDEdit;
    what->editor->init(what);
    gtk_window_set_title(GTK_WINDOW(what->editor->window),"Add new download");
    gtk_signal_connect(GTK_OBJECT(what->editor->cancel_button),"clicked",GTK_SIGNAL_FUNC(add_window_cancel), NULL);
    gtk_signal_connect(GTK_OBJECT(what->editor->ok_button),"clicked",GTK_SIGNAL_FUNC(add_window_ok),NULL);
    gtk_signal_connect(GTK_OBJECT(what->editor->window),"delete_event",GTK_SIGNAL_FUNC(add_window_cancel), NULL);
    what->editor->clear_url();
};

void init_add_clipboard_window(...) {
    if (OneDownload) return;
    init_add_window();
    tDownload *what=OneDownload;
    what->editor->paste_url();
    gtk_widget_grab_focus(what->editor->ok_button);
};

void init_add_dnd_window(char *url){
    if (OneDownload) return;
    init_add_window();
    tDownload *what=OneDownload;
    what->editor->set_url(url);
    gtk_widget_grab_focus(what->editor->ok_button);
};