/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <gtk/gtk.h>
#include <string.h>
#include "list.h"
#include "../main.h"
#include "../var.h"
#include "graph.h"
guchar graph_rgb_data[100*16*4];
static GdkRgbCmap *cmap;

gint graph_expose_event_handler(GtkWidget *widget,GdkEventExpose *event){
	draw_graph();
	return FALSE;
};

int draw_graph() {
    int XSize=2*(METER_LENGTH-1);
    int YSize=16;
    int WX,WY;
    gdk_window_get_size(MainWindow->window,&WX,&WY);
    gdk_draw_indexed_image(MainWindow->window,MainWindowGC,WX-3-XSize,WY-2-YSize,XSize,YSize,
                           GDK_RGB_DITHER_NONE,(guchar *)graph_rgb_data,XSize,cmap);
    gdk_flush();
   	return FALSE;
};

void recalc_graph() {
    if (!GlobalMeter) return;
    int XSize=2*(METER_LENGTH-1);
    int YSize=16;
    int WX,WY;
    gdk_window_get_size(MainWindow->window,&WX,&WY);
    memset(graph_rgb_data,15,XSize*YSize);

    int MAX=GlobalMeter->max();
    int MAX2=LocalMeter->max();
    MAX=MAX2>MAX?MAX2:MAX;
    int NUM=GlobalMeter->count();
    if (NUM>XSize) NUM=XSize;
    if (MAX>0) {
        int value=(YSize*GlobalMeter->last_value())/MAX;
        int value2=(YSize*LocalMeter->last_value())/MAX;
        for (int x=XSize-1;x>=0;x-=2) {
            for (int y=YSize-1;y>=(YSize-value);y--) {
                if (y==(YSize-value))
	                graph_rgb_data[y*XSize+x]=graph_rgb_data[y*XSize+x-1]=0;
	            else
                	graph_rgb_data[y*XSize+x]=graph_rgb_data[y*XSize+x-1]=5;
            };
            for (int y=YSize-1;y>=(YSize-value2);y--) {
	            graph_rgb_data[y*XSize+x]=graph_rgb_data[y*XSize+x-1]=10;
            };
            value=(YSize*GlobalMeter->next_value())/MAX;
            value2=(YSize*LocalMeter->next_value())/MAX;
        };
    };
};

void init_graph() {
    guint32 colors[16];
    for (int i=0;i<16;i++){
    	int a=(0xff * i)/15;
    	colors[i]=a << 16 | a <<8 | a;
    };
    int XSize=2*(METER_LENGTH-1);
    int YSize=16;
    int WX,WY;
    gdk_window_get_size(MainWindow->window,&WX,&WY);

    cmap=gdk_rgb_cmap_new(colors,16);
    memset(graph_rgb_data,15,XSize*YSize);
    gdk_window_clear_area(MainWindow->window,WX-3-XSize,WY-3-YSize,XSize,YSize);
    gdk_draw_indexed_image(MainWindow->window,MainWindowGC,WX-3-XSize,WY-2-YSize,XSize,YSize,
                           GDK_RGB_DITHER_NONE,(guchar *)graph_rgb_data,XSize,cmap);
    gdk_flush();
};
