/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#include "sortstr.h"
#include <string.h>
#include <stdio.h>

tSortString::tSortString() {
    body=NULL;
};

tSortString::tSortString(char *what,int len) {
    body=new char[len+2];
    strncpy(body,what,len);
    body[len]=0;
};

tSortString::~tSortString() {
    if (body){
    	delete(body);
    	body=NULL;
    };
};
//---------------------------------------------------------

tStrSortTree::tStrSortTree() {
    Top=NULL;
};

void tStrSortTree::init() {
    Top=NULL;
};

void tStrSortTree::simple_add(tSortString **where,tSortString *what) {
    tSortString **temp=where;
    while (*temp) {
    	int a=strcmp((*temp)->body,what->body);
    	if (a<0 || (a==0 && (*temp)->key < what->key))
            temp=(tSortString **)(&((*temp)->more));
        else
            temp=(tSortString **)(&((*temp)->less));  
    };
    *temp=what;
};

void tStrSortTree::add(tSortString *what) {
    simple_add(&Top,what);
    what->less=what->more=NULL;
};

void tStrSortTree::print(tSortString *top){
	if (!top) return;
	printf("%s:%i\n",top->body,top->key);
	print((tSortString *)(top->less));
	print((tSortString *)(top->more));
};

void tStrSortTree::del(tSortString *what) {
    tSortString **temp=&Top;
    while (*temp && *temp!=what) {
    	int a=strcmp((*temp)->body,what->body);
    	if (a<0 || (a==0 && (*temp)->key < what->key))
            temp=(tSortString **)(&((*temp)->more));
        else
            temp=(tSortString **)(&((*temp)->less));
    };
    if (*temp) *temp=(tSortString *)what->less;
    if (what->more) simple_add(temp,(tSortString *)what->more);
};

tSortString *tStrSortTree::find(char *what,int key){
    tSortString **temp=&Top;
    while (*temp) {
    	int a=strcmp((*temp)->body,what);
    	if (a<0 || (a==0 && (*temp)->key < key))
            temp=(tSortString **)&((*temp)->more);
        else{
        	if (a==0 && (*temp)->key==key) return *temp;
            temp=(tSortString **)&((*temp)->less);
        };
    };
    return NULL;
};


tStrSortTree::~tStrSortTree() {
    //do nothing %))
};

/* ---------------------------------------------------------------
 */

tHostsLimits::tHostsLimits(){
    init(0);
    Size=0;
    tree=new tStrSortTree;
};

void tHostsLimits::add(char *str,int port,int curent,int upper) {
    int len=strlen(str);
    tSortString *ins=new tSortString(str,len);
    insert(ins);
    Size+=len;
    ins->key=port;
    ins->curent=curent;
    ins->upper=upper;
    tree->add(ins);
};

void tHostsLimits::del(tSortString *what) {
    Num-=1;
    tree->del(what);
    if (what->prev)
        what->prev->next=what->next;
    else
        Last=what->next;
    if (what->next)
        what->next->prev=what->prev;
    else
        First=what->prev;
};

tSortString *tHostsLimits::last() {
    return (tSortString *)(Curent=Last);
};

tSortString *tHostsLimits::first() {
    return (tSortString *)(Curent=First);
};

tSortString *tHostsLimits::next() {
    return (tSortString *)(tQueue::next());
};

tSortString *tHostsLimits::prev() {
    return (tSortString *)(tQueue::prev());
};


void tHostsLimits::dispose() {
    tSortString *temp=(tSortString*)(First);
    tree->del(temp);
    Size-=temp->size();
    tQueue::dispose();
};

tSortString *tHostsLimits::find(char *host,int port) {
	return tree->find(host,port);
};

tHostsLimits::~tHostsLimits(){
	done();
	delete tree;
};
